// The contents of this file will be executed before any of
// your view controllers are ever executed, including the index.
// You have access to all functionality on the `Alloy` namespace.
//
// This is a great place to do any initialization for your app
// or create any global variables/functions that you'd like to
// make available throughout your app. You can easily make things
// accessible globally by attaching them to the `Alloy.Globals`
// object. For example:
//
// Alloy.Globals.someGlobalFunction = function(){};

var globalEvtMgr = require('/lib/eventmanager');
Alloy.Globals.ws = require('/lib/webservices');

var platformName = Titanium.Platform.osname;
var isAndroid = (platformName == 'android');
var isIOS = (platformName == 'iphone' || platformName == 'ipad');
var isIPad = ("ipad" == platformName);

if (isIOS)
{
	Alloy.Globals.lightFont = 'AvenirNext-Regular';
	Alloy.Globals.defaultFont = 'AvenirNext-Medium';
	Alloy.Globals.boldFont = 'AvenirNext-Bold';
}
else if (isAndroid)
{
	Alloy.Globals.lightFont = 'Roboto-Regular';
	Alloy.Globals.defaultFont = 'Roboto-Medium';
	Alloy.Globals.boldFont = 'Roboto-Bold';
}
else
{
	Alloy.Globals.lightFont = 'Arial';
	Alloy.Globals.defaultFont = 'Arial';
	Alloy.Globals.boldFont = 'Arial';
}
Alloy.Globals.fontAwesome = 'FontAwesome';

Alloy.Globals.appstate =
{
	loggedin: false
};
Ti.API.info('Alloy.Globals.state defined(' + JSON.stringify(Alloy.Globals.appstate) + ')');

Alloy.Globals.appconfig =
{
	hiliteColor: 'blue',
	menuGradient: {
        type: 'linear',
        startPoint: { x: '100%', y: '50%' },
        endPoint: { x: '0%', y: '50%' },
        colors: [ { color: '#2DBD96', offset: 0.0}, { color: '#4F9B88', offset: 0.5 }, { color: '#5CA08F', offset: 1.0 } ],
	}
};

function doShowActionBar(win, doShow)
{
	if (isAndroid)
	{
		var activity = win.activity;
		if (activity)
		{
			var actionBar = activity.actionBar;
			if (actionBar)
			{
				if (doShow)
					actionBar.show();
				else
					actionBar.hide();
			}
		}
	}
}

function putIfAbsent(item, key, value)
{
	if (!(key in item))
		item[key] = value;
	else
		value = item[key];
	return value;
}

var windowArr = [];
function doOpenWindow(name, args, cbfn)
{
	var controller = Alloy.createController(name, args);
	var view = controller.getView();
	if (cbfn)
		cbfn(controller, view);
	windowArr.push(view);
	view.addEventListener("close", function(e)
	{
		var ndx = windowArr.indexOf(view);
		if (ndx >= 0 && ndx < windowArr.length)
			windowArr.splice(ndx, 1);
	});
	Alloy.Globals.tab.open(view);
}

// eof
