// --------------------------------------------------------------------------------
// Implementation by Henry David Spells III
// SpellsVentures LLC Confidential
// --------------------
// Copyright 2013 Spells Ventures LLC
//  All Rights Reserved.
// 
// NOTICE: All information contained herein is, and remains the property of
// Spells Ventures LLC and its suppliers, if any. The intellectual and technical
// concepts contained herein are proprietary to Spells Ventures LLC nd its
// suppliers and may be covered by U.S. and Foreign Patents, patents in process,
// and are protected by trade secret or copyright law. Dissemination of this
// information or reproduction of this material is strictly forbidden unless prior
// written permission is obtained from Spells Ventures LLC.
//
// --------------------------------------------------------------------------------

var eventRegistry = {};

function isEmpty(obj)
{
   for (var key in obj)
   {
      if (obj.hasOwnProperty(key))
      {
         return false;
      }
   }
   return true;
}

exports.addEventListener = function(name, obj, fn)
{
	if (!(name in eventRegistry))
		eventRegistry[name] = {};
	var obj2fn = eventRegistry[name];
	obj2fn[obj] = fn;
};

exports.removeEventListener = function(name, obj)
{
	if (name in eventRegistry)
	{
		if (obj == null)
		 	delete eventRegistry[name];
		else
		{
			var obj2fn = eventRegistry[name];
			if (obj in obj2fn)
			 	delete obj2fn[obj];
			if (isEmpty(obj2fn))
			 	delete eventRegistry[name];
		 }
	}
};

exports.fireEvent = function(name, evt)
{
	if (name in eventRegistry)
	{
		var obj2fn = eventRegistry[name];
		for (var obj in obj2fn)
		{
			fn = obj2fn[obj];
			if (fn)
				fn(evt, obj);
		}
	}
};
