// --------------------------------------------------------------------------------
// Implementation by Henry David Spells III
// SpellsVentures LLC Confidential
// --------------------
// Copyright 2015 Spells Ventures LLC
//  All Rights Reserved.
// 
// NOTICE: All information contained herein is, and remains the property of
// Spells Ventures LLC and its suppliers, if any. The intellectual and technical
// concepts contained herein are proprietary to Spells Ventures LLC nd its
// suppliers and may be covered by U.S. and Foreign Patents, patents in process,
// and are protected by trade secret or copyright law. Dissemination of this
// information or reproduction of this material is strictly forbidden unless prior
// written permission is obtained from Spells Ventures LLC.
//
// --------------------------------------------------------------------------------

var win = $.win;

function doOnClose(e)
{
	globalEvtMgr.removeEventListener('scoretabblur', 'popup-control');
}

var _cbfn = function(e, name)
{
	closeImp();
};

function closeImp()
{
	Ti.API.info('sliderdraw::closeImp test');
	if (null != win)
	{
		Ti.API.info('sliderdraw::closeImp');
		win.close();
		win = null;
	}
}

function doClose(e)
{
	_cbfn(e, "");
}

function doOnOpen(e)
{
	Ti.API.info('sliderdraw::doOnOpen');
	// On Android you can still click on tabs when this window is up
	// This closes the popup control window when you click on another tab
	globalEvtMgr.addEventListener('scoretabblur', 'popup-control', doClose);
	if (isAndroid)
		win.activity.actionBar.hide();
}

function putIfAbsent(item, key, value)
{
	if (!(key in item))
		item[key] = value;
}

$.initviewprops = function(bgViewProps, listViewProps)
{
	for (ndx in bgViewProps)
	{
		$.backgroundView[ndx] = bgViewProps[ndx];
	}

	for (ndx in listViewProps)
	{
		$.listView[ndx] = listViewProps[ndx];
	}
};

var _listVals = [];
$.initlist = function(listVals)
{
	_listVals = listVals;
	var ndx;
	for (ndx in listVals)
	{
		var lvitem = listVals[ndx];
		putIfAbsent(lvitem, "properties", {accessoryType: Ti.UI.LIST_ACCESSORY_TYPE_NONE});
		lvitem.properties.width = Ti.UI.SIZE;
	}

	Ti.API.info('initlist(' + listVals + ')');
	$.optionsSection.setItems(listVals);
};

$.initview = function(listVals, bgViewProps, listViewProps, sliderDrawWidth, doAnimate, cbfn)
{
	Ti.API.info('initview');
	$.initviewprops(bgViewProps, listViewProps);
	$.initlist(listVals);

  	var animateview = $.listView;
	_cbfn = function(e, name)
  	{
   		Ti.API.info('_cbfn(' + name + ')');
		cbfn(e, name);
  	};

	if (doAnimate)
	{
		animateview.setLeft(-sliderDrawWidth);
		animateview.animate({left: 0, duration: 200});
	}
};

$.initialize = function(listVals, bgViewProps, listViewProps, sliderDrawWidth, doAnimate, cbfn)
{
	$.initviewprops(bgViewProps, listViewProps);
	$.initlist(listVals);

	if (isAndroid)
		doAnimate = false;
  	var popup = $.getView();
  	var animateview = $.listView;
	_cbfn = function(e, name)
  	{
   		Ti.API.info('_cbfn(' + name + ')');
		if (doAnimate)
		{
			Alloy.Globals.tabGroup.animate({left: 0, right: 0, duration: 200});
	   		Ti.API.info('_cbfn(' + name + ') animateview(' + animateview + ')');
			animateview.animate({right: -sliderDrawWidth, duration: 150}, function()
			{
	  			closeImp();
	  			setTimeout(function()
	  			{
		  			cbfn(e, name);	  				
	  			}, 50);
			});
		}	
		else
		{
  			closeImp();
  			cbfn(e, name);
		}
  	};

	if (doAnimate)
	{
		animateview.setRight(-sliderDrawWidth);
		Alloy.Globals.tabGroup.animate({left: -sliderDrawWidth, right: sliderDrawWidth, duration: 200});
	}
	var props = {navBarHidden: true};
  	popup.open(props);
	if (doAnimate)
		animateview.animate({right: 0, duration: 200});
};

$.listView.addEventListener('itemclick', function(e)
{
	var lvitem = $.optionsSection.getItemAt(e.itemIndex);
 	Ti.API.info('_cbfn(' + JSON.stringify(lvitem) + ')');
 
	var eventname = _listVals[e.itemIndex].eventname;
	_cbfn(e, eventname);
	$.listView.deselectItem(0, e.itemIndex);
});

// eof